Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/WordProperty.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/WordProperty.java	(revision 3054)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/WordProperty.java	(revision 3055)
@@ -3,8 +3,11 @@
 import java.io.IOException;
 import java.util.List;
 
+import org.apache.commons.lang.math.IntRange;
+import org.txm.objects.Match;
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
 import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.searchengine.cqp.corpus.query.MatchUtils;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
 
 /**
@@ -62,7 +65,7 @@
 	}
 	
 	public String cpos2Str(int position) throws UnexpectedAnswerException, IOException, CqiServerError {
-		return CorpusManager.getCorpusManager().getCqiClient().cpos2Str(this.getQualifiedName(), new int[] {position})[0];
+		return CorpusManager.getCorpusManager().getCqiClient().cpos2Str(this.getQualifiedName(), new int[] { position })[0];
 	}
 	
 	public String[] cpos2Str(int[] positions) throws UnexpectedAnswerException, IOException, CqiServerError {
@@ -82,25 +85,35 @@
 	}
 	
 	public int str2Id(String value) throws UnexpectedAnswerException, IOException, CqiServerError {
-		return CorpusManager.getCorpusManager().getCqiClient().str2Id(this.getQualifiedName(), new String[] {value})[0];
+		return CorpusManager.getCorpusManager().getCqiClient().str2Id(this.getQualifiedName(), new String[] { value })[0];
 	}
 	
 	public String getCQLTest(String value) {
-		return this.getName() + "=\"" +  CQLQuery.addBackSlash(value)+ "\"";
+		return this.getName() + "=\"" + CQLQuery.addBackSlash(value) + "\"";
 	}
 	
 	public String getCQLTest(List<String> values) {
 		StringBuilder sb = new StringBuilder();
 		sb.append(this.getName() + "=\""); //$NON-NLS-1$
-		for (int i = 0 ; i < values.size() ; i++) {
+		for (int i = 0; i < values.size(); i++) {
 			String s = values.get(i);
 			s = CQLQuery.addBackSlash(s);
-			sb.append(s); //$NON-NLS-1$
-			if (i < values.size() -1) {
+			sb.append(s);
+			if (i < values.size() - 1) {
 				sb.append("|"); //$NON-NLS-1$
 			}
 		}
 		sb.append("\"");
 		return sb.toString();
+	}
+	
+	public String[] getValues() throws UnexpectedAnswerException, IOException, CqiServerError {
+		int n = CorpusManager.getCorpusManager().getCqiClient().lexiconSize(this.getQualifiedName());
+		int[] ids = MatchUtils.toPositions(0, n - 1);
+		return CorpusManager.getCorpusManager().getCqiClient().id2Str(this.getQualifiedName(), ids);
+	}
+	
+	public int getNValues() throws UnexpectedAnswerException, IOException, CqiServerError {
+		return CorpusManager.getCorpusManager().getCqiClient().lexiconSize(this.getQualifiedName());
 	};
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/MatchUtils.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/MatchUtils.java	(revision 3054)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/query/MatchUtils.java	(revision 3055)
@@ -70,21 +70,31 @@
 	 * @return array of int position from a Match start to another Match end
 	 */
 	public static int[] toPositions(Match match1, Match match2) {
-		int len = match2.end - match1.start + 1;
+		return toPositions(match1.start, match2.end);
+	}
+	
+	/**
+	 * 
+	 * @param match1
+	 * @param match2
+	 * @return array of int position from a Match start to another Match end
+	 */
+	public static int[] toPositions(int from, int to) {
+		int len = to - from + 1;
 		
 		if (len <= 0) {
 			return new int[0];
 		}
 		else if (len == 1) {
-			return new int[] { match1.start };
+			return new int[] { from };
 		}
 		else if (len == 2) {
-			return new int[] { match1.start, match2.end };
+			return new int[] { from, to };
 		}
 		else {
 			int[] positions = new int[len];
 			int n = 0;
-			for (int i = match1.start; i <= match2.end; i++) {
+			for (int i = from; i <= to; i++) {
 				positions[n++] = i;
 			}
 			return positions;
Index: tmp/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/RecodeCorpus.java
===================================================================
--- tmp/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/RecodeCorpus.java	(revision 3054)
+++ tmp/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/commands/RecodeCorpus.java	(revision 3055)
@@ -36,40 +36,45 @@
 import org.txm.utils.logger.Log;
 
 public class RecodeCorpus extends AbstractHandler {
-
+	
 	public static final String ID = RecodeCorpus.class.getCanonicalName();
-
-	@Option(name="conversionFile", usage="conversionFile", widget="File", required=true, def="conv.tsv")
+	
+	@Option(name = "conversionFile", usage = "conversionFile", widget = "File", required = true, def = "conv.tsv")
 	protected File conversionFile;
-	@Option(name="oldType", usage="oldType", widget="String", required=true, def="pos")
+	
+	@Option(name = "oldType", usage = "oldType", widget = "String", required = true, def = "pos")
 	protected String oldType;
-	@Option(name="newType", usage="newType", widget="String", required=true, def="pos2")
+	
+	@Option(name = "newType", usage = "newType", widget = "String", required = true, def = "pos2")
 	protected String newType;
-	@Option(name="gestionInconnus", usage="oldType", widget="String", required=true, def="abandon")
+	
+	@Option(name = "gestionInconnus", usage = "how to manage failed conversion", widget = "String", required = true, def = "abandon")
 	protected String gestionInconnus;
-
+	
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
-
+		
 		ISelection isel = HandlerUtil.getCurrentSelection(event);
-		if (isel == null) return null ;
-		if (!(isel instanceof IStructuredSelection)) return null ;
+		if (isel == null) return null;
+		if (!(isel instanceof IStructuredSelection)) return null;
 		IStructuredSelection selection = (IStructuredSelection) isel;
 		Object s = selection.getFirstElement();
 		if (!(s instanceof MainCorpus)) return null;
-
+		
 		final MainCorpus corpus = (MainCorpus) s;
-
+		
 		try {
 			if (ParametersDialog.open(this)) {
-
-				JobHandler job = new JobHandler("Recode corpus "+corpus) {
+				
+				JobHandler job = new JobHandler("Recode corpus " + corpus) {
+					
 					@Override
 					protected IStatus run(IProgressMonitor monitor) {
 						try {
 							recode(corpus, conversionFile, oldType, newType, monitor);
-						} catch (Exception e) {
-							System.out.println("Fail to convert properties of corpus "+corpus);
+						}
+						catch (Exception e) {
+							System.out.println("Fail to convert properties of corpus " + corpus);
 							e.printStackTrace();
 							return Status.CANCEL_STATUS;
 						}
@@ -79,70 +84,76 @@
 				job.startJob();
 				return corpus;
 			}
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			e.printStackTrace();
 		}
-
+		
 		return corpus;
 	}
-
-	public static JobHandler recode(final MainCorpus corpus, CorpusRuledConvertion crc, String oldType, String newType, IProgressMonitor monitor) throws IOException, CqiClientException, XMLStreamException {
-
+	
+	public static JobHandler recode(final MainCorpus corpus, CorpusRuledConvertion crc, String oldType, String newType, IProgressMonitor monitor) throws IOException, CqiClientException,
+			XMLStreamException {
+		
 		Project project = corpus.getProject();
 		if (!"xtz".equals(project.getImportModuleName())) {
-			System.out.println("Corpus "+corpus+" was imported with XTZ import module");
+			System.out.println("Corpus " + corpus + " was not imported with the XTZ import module");
 			return null;
 		}
 		
 		Property p1 = corpus.getProperty(oldType);
 		if (p1 == null) {
-			System.out.println("Corpus "+corpus+" has not property "+oldType);
+			System.out.println("Corpus " + corpus + " has not property " + oldType);
 			return null;
 		}
-
-		System.out.println("Recoding "+corpus+" property "+oldType+" in "+newType);
-
+		
+		System.out.println("Recoding " + corpus + " property " + oldType + " in " + newType);
+		
 		monitor.beginTask("Recoding corpus properties...", 2);
 		monitor.setTaskName("Recoding XML-TXM files");
 		// apply conversion file
 		if (!crc.process(corpus)) {
-			System.out.println("Failed to edit XML-TXM of the corpus: "+corpus);
+			System.out.println("Failed to edit XML-TXM of the corpus: " + corpus);
 			return null;
 		}
 		monitor.worked(1);
 		
 		// update corpus indexes and edition
-//		String txmhome = Toolbox.getTxmHomePath();
-
+		// String txmhome = Toolbox.getTxmHomePath();
 		
-		project.setDoMultiThread(false); //too soon
+		
+		project.setDoMultiThread(false); // too soon
 		project.setDoUpdate(true);
-
-//		monitor.setTaskName("Updating corpus");
-//		File scriptDir = new File(txmhome, "scripts/groovy/user/org/txm/scripts/importer/xtz");
-//		File script = new File(scriptDir, "xtzLoader.groovy");
+		
+		// monitor.setTaskName("Updating corpus");
+		// File scriptDir = new File(txmhome, "scripts/groovy/user/org/txm/scripts/importer/xtz");
+		// File script = new File(scriptDir, "xtzLoader.groovy");
 		System.out.println(NLS.bind(KRAnnotationUIMessages.updatingTheP0Corpus, corpus));
 		JobHandler ret = ExecuteImportScript.executeScript(project);
 		Display.getDefault().syncExec(new Runnable() {
+			
 			@Override
-			public void run() {CloseEditorsUsing.corpus(corpus);}
+			public void run() {
+				CloseEditorsUsing.corpus(corpus);
+			}
 		});
 		monitor.worked(1);
 		return ret;
 	}
-
-	public static JobHandler recode(final MainCorpus corpus, LinkedHashMap<Pattern, String> rules, String oldType, String newType, IProgressMonitor monitor) throws IOException, CqiClientException, XMLStreamException {
-
+	
+	public static JobHandler recode(final MainCorpus corpus, LinkedHashMap<Pattern, String> rules, String oldType, String newType, IProgressMonitor monitor) throws IOException, CqiClientException,
+			XMLStreamException {
+		
 		// apply conversion file
 		CorpusRuledConvertion crc = new CorpusRuledConvertion(rules, newType, oldType);
-		return recode(corpus, crc, oldType, newType , monitor);
+		return recode(corpus, crc, oldType, newType, monitor);
 	}
-
+	
 	public static JobHandler recode(final MainCorpus corpus, File conversionFile, String oldType, String newType, IProgressMonitor monitor) throws IOException, CqiClientException, XMLStreamException {
-		System.out.println("Create CorpusRuledConvertion with "+conversionFile);
+		System.out.println("Create CorpusRuledConvertion with " + conversionFile);
 		// apply conversion file
 		CorpusRuledConvertion crc = new CorpusRuledConvertion(conversionFile, oldType, newType);
-
+		
 		return recode(corpus, crc, oldType, newType, monitor);
 	}
-}
\ No newline at end of file
+}
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/DeleteObject.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/DeleteObject.java	(revision 3054)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/handlers/results/DeleteObject.java	(revision 3055)
@@ -77,6 +77,7 @@
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		
 		final IStructuredSelection selection = (IStructuredSelection) HandlerUtil.getCurrentSelection(event);
+		if (selection.isEmpty()) return null;
 		
 		if (!askContinueToDelete(selection)) {
 			return null;
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/LangSection.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/LangSection.java	(revision 3054)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/LangSection.java	(revision 3055)
@@ -1,6 +1,7 @@
 package org.txm.rcp.editors.imports.sections;
 
 import java.io.File;
+import java.util.ArrayList;
 import java.util.Arrays;
 import java.util.Locale;
 
@@ -16,6 +17,11 @@
 import org.eclipse.ui.forms.widgets.ScrolledForm;
 import org.eclipse.ui.forms.widgets.TableWrapData;
 import org.eclipse.ui.forms.widgets.TableWrapLayout;
+import org.txm.Toolbox;
+import org.txm.annotation.core.AnnotationEngine;
+import org.txm.core.engines.Engine;
+import org.txm.core.engines.EngineType;
+import org.txm.core.engines.EnginesManager;
 import org.txm.objects.Project;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.treetagger.core.preferences.TreeTaggerPreferences;
@@ -32,6 +38,8 @@
 	
 	Button btnSelectAnnotate;
 	
+	Combo annotateEngineCombo;
+	
 	Button btnSelectLang;
 	
 	Combo langcombo;
@@ -65,6 +73,29 @@
 		btnSelectAnnotate = toolkit.createButton(sectionClient, TXMUIMessages.annotateTheCorpus, SWT.CHECK);
 		toolkit.createLabel(sectionClient, ""); //$NON-NLS-1$
 		
+		
+		
+		EnginesManager<? extends Engine> ema = Toolbox.getEngineManager(EngineType.ANNOTATION);
+		ArrayList<String> engines = new ArrayList<>();
+		for (String engine : ema.getEngines().keySet()) {
+			AnnotationEngine e = (AnnotationEngine) ema.getEngine(engine);
+			if (e.isAutomatic()) {
+				engines.add(engine);
+			}
+		}
+		if (engines.size() > 1) {
+			
+			toolkit.createLabel(sectionClient, "Annotation engine"); //$NON-NLS-1$
+			
+			annotateEngineCombo = new Combo(sectionClient, SWT.BORDER);
+			annotateEngineCombo.setLayoutData(getTextGridData());
+			annotateEngineCombo.setToolTipText("Annotation engines");
+			annotateEngineCombo.setItems(engines.toArray(new String[engines.size()]));
+			annotateEngineCombo.setText(annotateEngineCombo.getItem(0));
+		}
+		
+		// if widget selected change the radio buttons value
+		
 		btnGuessLang = toolkit.createButton(sectionClient, TXMUIMessages.guessColon, SWT.RADIO);
 		toolkit.createLabel(sectionClient, ""); //$NON-NLS-1$
 		
@@ -151,6 +182,10 @@
 		
 		langcombo.setText(defaultLang);
 		btnSelectAnnotate.setSelection(annotate);
+		
+		if (annotateEngineCombo != null) {
+			annotateEngineCombo.setText(project.getImportParameters().node("annotate").get("engine", "TreeTagger"));
+		}
 	}
 	
 	@Override
@@ -170,6 +205,11 @@
 			
 			project.setAnnotate(btnSelectAnnotate.getSelection());
 			project.setLang(lang);
+			
+			if (annotateEngineCombo != null) {
+				project.getImportParameters().node("annotate").put("engine", annotateEngineCombo.getText());
+			}
+			
 			return true;
 		}
 		return true;
